<?php
// VERSION 1.5.2
// PHP-based Untl Uru player lister for automatic interpreters based on
//     structure "tiana 0x4"
// by The.Modificator
// 
// This is free code. Use it however you want, but please give credits where
// credits should be given.
// 
// Change log:
// 2005-06-30 The.Modificator
//     Version 1.1.0: Should also work for Alcugs servers now.
// 2005-07-11 Thorsten Rotering
//     Version 1.1.1: Corrected if-condition for non-empty printouts
// 2005-09-12 The.Modificator
//     Version 1.5.0: Added support for the KI journal entry based player
//     listing disabling feature.
// 2005-09-13 The.Modificator
//     Version 1.5.1: KI journal entry based player listing disabling feature
//     should also work for Alcugs now.
//     Version 1.5.2: Some optimizations.

error_reporting(0);       //disable all errors/warnings/whatever

////////////////////////////////////////////////////////////////////////////////
// Change values below
////////////////////////////////////////////////////////////////////////////////

// database hostname:
$dbserver = "localhost";

// database username:
$dbuser = "root";

// database password
$dbpassword = "";

// database name:
$dbname = "vaultdb_test";

// change this to 'true', if you run an Alcugs Server:
$alcugs = false;

// if this is 'true', a player will be usually visible if he doesn't create a KI
// journal entry that makes him invisible.
// if this is 'false', a player will be usually invisible if he doesn't create a
// KI journal entry that makes him visible.
$usuallyvisible = true;

////////////////////////////////////////////////////////////////////////////////
// Change values above
////////////////////////////////////////////////////////////////////////////////

if(!($dbcid = mysql_connect($dbserver, $dbuser, $dbpassword)))
{
	exit("ERR\n#1 Could not connect to database.");
}

if(!mysql_select_db($dbname))
{
	mysql_close($dbcid);
	exit("ERR\n#2 Could not select the database.");
}

////////////////////////////////////////////////////////////////////////////////

function check_visibility($nodeid)
{
	global $dbcid, $usuallyvisible, $alcugs;
	
	// gets the index of the Player node's "AgeJournalsFolder"
	if($alcugs)
		$sql = "SELECT nodes.`idx` FROM `ref_vault` AS refs, `vault` AS " .
		       "nodes WHERE refs.`id2` = " . $nodeid . " AND nodes.`idx` = " .
		       "refs.`id3` AND nodes.`type` = 22 /*FLDR*/ AND nodes.`torans` " .
		       "= 14 /*AgeJournalsFolder*/ ;";
	else		
		$sql = "SELECT nodes.`Idx` FROM `NodeRefs` AS refs, `Nodes` AS nodes " .
		       "WHERE refs.`ParentIdx` = " . $nodeid . " AND nodes.`Idx` = " .
		       "refs.`ChildIdx` AND nodes.`NodeType` = 22 /*FLDR*/ AND " .
		       "nodes.`Int32_1` = 14 /*AgeJournalsFolder*/ ;";
	
	$ret = mysql_query($sql,$dbcid);
	if(!$ret)
	{
		mysql_close($dbcid);
		exit("ERR\n#4 SQL error while checking visibility");
	}
	
	$agejfolderidxrow = mysql_fetch_array($ret);
	if(!$agejfolderidxrow[0])
	{
		mysql_close($dbcid);
		exit("ERR\n#5 Data error while checking visibility");
	}

	if($alcugs)
		$sql = "SELECT `id3` FROM `ref_vault` WHERE `id2` = " .
		       $agejfolderidxrow[0] . ";";
	else
		$sql = "SELECT `ChildIdx` FROM `NodeRefs` WHERE `ParentIdx` = " .
		       $agejfolderidxrow[0] . ";";
	
	$ret = mysql_query($sql,$dbcid);
	if(!$ret)
	{
		mysql_close($dbcid);
		exit("ERR\n#6 SQL error while checking visibility");
	}
	
	while($subfolderrow = mysql_fetch_array($ret))
	{
		if($alcugs)
			$sql = "SELECT nodes.`entry_name` FROM `ref_vault` AS refs, " .
			       "`vault` AS nodes WHERE refs.`id2` = " . $subfolderrow[0] .
			       " AND nodes.`idx` = refs.`id3` AND nodes.`NodeType` IN " .
			       "(26 /*IMG*/, 25 /*TXT*/);";
		else
			$sql = "SELECT nodes.`String64_1` FROM `NodeRefs` AS refs, " .
			       "`Nodes` AS nodes WHERE refs.`ParentIdx` = " .
			       $subfolderrow[0] . " AND nodes.`Idx` = refs.`ChildIdx` " .
			       "AND nodes.`NodeType` IN (26 /*IMG*/, 25 /*TXT*/);";
		
		$subret = mysql_query($sql,$dbcid);
		if(!$subret)
		{
			mysql_close($dbcid);
			exit("ERR\n#7 SQL error while checking visibility");
		}
		
		while($textrow = mysql_fetch_array($subret))
		{
			if($textrow[0] == "UUL_v_on")
				return true;
			else if($textrow[0] == "UUL_v_off")
				return false;
		}
	}
	
	return $usuallyvisible;
}

////////////////////////////////////////////////////////////////////////////////

if($alcugs)
	$sql = "SELECT count(*) FROM `vault` WHERE `type` = 23 AND `torans` = 1;";
else
	$sql = "SELECT count(*) FROM `Nodes` WHERE `NodeType` = 23 AND " .
	       "`Int32_1` = 1;";

$ret = mysql_query($sql,$dbcid);
$row = mysql_fetch_array($ret);

$numplayers = $row[0];

if ($numplayers == "0")
{
	print "NUL\nNo visible players are connected.";
}
else
{
	if($alcugs)
		$sql = "SELECT `owner`, `avie`, `entry_name` FROM `vault` WHERE " .
		       "`type` = 23 AND `torans` = 1;";
	else
		$sql = "SELECT `OwnerIdx`, `IString64_1`, `String64_1` FROM `Nodes` " .
		       "WHERE `NodeType` = 23 AND `Int32_1` = 1;";
	
	$ret = mysql_query($sql,$dbcid);
	
	if(!$ret)
	{
		mysql_close($dbcid);
		exit("ERR\n#3 SQL error");
	}
	
	$output="";
	$counter=0;
	while($row = mysql_fetch_array($ret))
	{
		if ($row[1]!="")
		{
			if(check_visibility($row[0]))
			{
				$output.="\n\n" . $row[1] . "\n" . $row[0] . "\n" . $row[2];
				$counter++;
			}
		}
	}
	
	if($counter>0)
		print "LST\n" . $counter . "\n" . $output;
	else
		print "NUL\nNo visible players are connected.";
}

mysql_close($dbcid);

/* Output format:
	variables are bold and uppercase and all strings

	//there's an error
	"ERR" + newline + MESSAGE
	
	//there are no players connected:
	"NUL" + newline + MESSAGE ("No visible players are connected.")
	
	//there are some players connected:
	"LST" + newline +
	   COUNT + newline
	   + [COUNT times:](newline + newline + NAME + newline + KIID + newline +
	                                                                        AGE)
*/

?>
